class User < ActiveRecord::Base
  attr_accessor :password
  
  validates_uniqueness_of :neptun
  validates_presence_of   :neptun
  validates_length_of     :password, :within => 4..20, :if => :password_required?
  
  validates_confirmation_of :password, :if => :password_required?
  
  before_save :encrypt_password
  
  def password_required?
    encrypted_password.blank? || !password.blank?
  end
  
  def encrypt_password
    return if password.blank?
    if new_record?
      #self.salt = ActiveSupport::SecureRandom.base64(8)
      self.salt = Digest::SHA1.hexdigest("#{Time.now}--#{email}")
    end
    self.encrypted_password= User.encrypt(password,salt)
  end
  
  def self.encrypt(pass,salt)
    #Digest::SHA2.hexdigest(salt+pass)
    Digest::SHA1.hexdigest("#{salt}--#{pass}")
  end
  
end
